without warning
without type_check
include wildcard.e
include get.e
include file.e
object token_pointer
object token_string

global sequence constants,subs
global constant NUMERIC=1,
                SEQUENCE=2,
                KEYWORD=3,
                COMMENT=4,
                SUB_CALL=5,
                EQ=6,
                PAR=7,
                EQUATION=8,
                OTHER=0,
                keyword_start={"##","az","AZ"},
                keyword_finish={"az","AZ","__","09"},
                numeric_start={"09","--",".."},
                numeric_finish={"xx","hh","AF","af","09",".."},
                include_start={{0,31},{33,255}},
                include_finish={{0,8},{11,31},{33,255}},
                reserved_words={
    "if", "end", "then", "procedure", "else", "for", "return",
    "do", "elsif", "while", "type", "constant", "to", "and", "or",
    "exit", "function", "global", "by", "not", "include",
    "with", "without", "xor"}&{
    "length", "puts", "integer", "sequence", "position", "object",
    "append", "prepend", "print", "printf", 
    "clear_screen", "floor", "getc", "gets", "get_key",
    "rand", "repeat", "atom", "compare", "find", "match",
    "time", "command_line", "open", "close", "trace", "getenv",
    "sqrt", "sin", "cos", "tan", "log", "system", "date", "remainder",
    "power", "machine_func", "machine_proc", "abort", "peek", "poke", 
    "call", "sprintf", "arctan", "and_bits", "or_bits", "xor_bits",
    "not_bits", "pixel", "get_pixel", "mem_copy", "mem_set",
    "c_proc", "c_func", "routine_id", "call_proc", "call_func", 
    "poke4", "peek4s", "peek4u", "profile", "equal", "system_exec",
    "platform"}
global sequence sub_pre,sub_post,types,lib
types={
{"void",        "",     "",0},
{"boolean",     "CHAR", "atom",1},
{"byte",        "CHAR", "atom",1},
{"char",        "CHAR", "atom",1},
{"short",       "SHORT","atom",1},
{"int",         "INT",  "atom",1},
{"long",        "LONG", "atom",1},
{"float",       "FLOAT","atom",2},
{"double",      "DOUBLE","atom",1}
}

global function get_par()
        atom pars
        if token_string[token_pointer] !='('then return 0 end if
        pars=1
        for i = token_pointer+1 to length(token_string) do
                pars+=token_string[i]='('
                pars-=token_string[i]=')'
                if pars=0 then token_pointer=i return 1 end if
        end for
        token_pointer=length(token_string)+1
        return 1
end function

global function get_comment()
        if (token_pointer+1)<length(token_string) and equal(token_string[token_pointer..token_pointer+1],"//") !=1 then return 0 end if
        for i = token_pointer+1 to length(token_string) do
                if token_string[i]=10 then token_pointer=i+1 return 1 end if
        end for
        token_pointer=length(token_string)+1
        return 1
end function

global function get_comment2()
        if (token_pointer+1)<length(token_string) and equal(token_string[token_pointer..token_pointer+1],"/*") !=1 then return 0 end if
        for i = token_pointer+1 to length(token_string)-1 do
                if token_string[i]='*' and token_string[i+1]='/' then token_pointer=i+2 return 1 end if
        end for
        token_pointer=length(token_string)+1
        return 1
end function

global function advance(sequence s,sequence b)
integer c
        c=length(s)
        for a=1 to length(s) do
                if token_string[token_pointer]<s[a][1] or token_string[token_pointer]>s[a][2] then c-=1 if c<1 then return 0 end if end if
        end for
        token_pointer+=1
        for i = token_pointer to length(token_string) do
        c=length(b)
                for a=1 to length(b) do
                        if token_string[i]<b[a][1] or token_string[i]>b[a][2] then
                                c-=1
                                if c<1 then token_pointer=i return 1 end if
                        end if
                end for
        end for
        token_pointer=length(token_string)+1
        return 1
end function

global sequence includes
includes={}

global function read_whole_file(sequence file_name)
sequence file
        atom file_handle,file_length,junk
        sequence paths
        file_name=lower(file_name)
        if find(file_name,includes) then return {} end if
        paths={"","c:\\euphoria\\include\\"}
        for i = 1 to length(paths) do
        file_handle=open(paths[i]&file_name,"r")
        if file_handle>1 then exit end if
        end for

        if file_handle>1 then
        includes&={file_name}
        if not seek(file_handle,-1) then end if
        file_length=where(file_handle)
        if not seek(file_handle,0) then end if
        file=get_bytes(file_handle,file_length)
        close(file_handle)
        return file
        else
        return {}
        end if
end function

global function get_tokens(sequence b)
        integer c,oldc
        object r,ret
        ret={}
        token_string=b
        c=1
        while 1 do
                if c>length(b) then exit end if
                token_pointer=c
                if advance(keyword_start,keyword_finish) then
                        ret&={{KEYWORD,b[c..token_pointer-1]}}
                        c=token_pointer--keyword
                        if ret[length(ret)][2][1]='i' then
                        if equal(ret[length(ret)][2],"include") then
                                c+=1
                                token_pointer=c
                                if advance(include_start,include_finish) then
                                ret[length(ret)][1]=OTHER
                                r=token_pointer
                                ret&=get_tokens(read_whole_file(b[c..token_pointer-1]))
                                token_string=b
                                c=r
                        end if end if end if
                elsif b[c]=',' then
                        ret&={{EQ,','}} c+=1
                elsif advance(numeric_start,numeric_finish) then--numeric
                        if equal(b[c..c+1],"0x") then
                        r=value("#"&b[c+2..token_pointer-1])
                        elsif b[token_pointer-1]='h' then
                        r=value("#"&b[c..token_pointer-2])
                        else
                        r=value(b[c..token_pointer-1])
                        end if
                        ret&={{NUMERIC,r[2]}}
                        c=token_pointer
                elsif b[c]=')' then
                        ret&={{PAR,')'}} c+=1
                elsif b[c]='(' then
                        ret&={{PAR,'('}} c+=1
                elsif b[c]='/' and get_comment2() then
                        c=token_pointer
                elsif b[c]='/' and get_comment() then
                        c=token_pointer
                else
                        c+=1
                end if
        end while
        return ret
end function
atom type_num
function find_type(object t)
        for i = 1 to length(types) do
                if equal(t,types[i][1]) then type_num=i return 1 end if
        end for
        return 0
end function
subs={}
constants={}
global function process_tokens(sequence tokens)
        object junk
        sequence sub_name,ret,params,c_params,sub_params--,variables,types
        sequence glprocs
        integer j,func,sub_end
        ret={}
        j=1
        glprocs={}
        while 1 do
                if j>length(tokens) then exit end if
                if tokens[j][1]=KEYWORD then
                        if equal(tokens[j][2],"typedef") and (not find_type(tokens[j+2][2])) and find_type(tokens[j+1][2]) then
                                if length(types[type_num][2]) then
                                types&={types[type_num]}
                                types[length(types)][1]=tokens[j+2][2]
                                end if
                                j+=3
                        elsif equal(tokens[j][2],"typedef") and (not find_type(tokens[j+3][2])) and find_type(tokens[j+2][2]) and length(types[type_num][2]) then
                                types&={types[type_num]}
                                types[length(types)][1]=tokens[j+3][2]
                                j+=4
                        elsif equal(tokens[j][2],"typedef") and find(tokens[j+1][2],{"struct","class"}) then
                                types&={{"unkown","POINTER","object",0}}
                                types[length(types)][1]=tokens[j+3][2]
--                                ret&=sprintf("--unknown %s %s %s %s\n",{tokens[j][2],tokens[j+1][2],tokens[j+2][2],tokens[j+3][2]})
                                j+=4
                        elsif equal(tokens[j][2],"typedef") then
                                types&={{"unkown","POINTER","object",0}}
                                types[length(types)][1]=tokens[j+2][2]
--                                ret&=sprintf("--unknown %s %s %s\n",{tokens[j][2],tokens[j+1][2],tokens[j+2][2]})
                                j+=3
                        elsif equal(tokens[j][2],"#define") and not find(tokens[j+1][2],constants)  and not find(tokens[j+1][2],subs) then
                                j+=1
                                constants&={tokens[j][2]}
                                ret&="global constant "&tokens[j][2]&"="
                                j+=1
                                if tokens[j][1]=NUMERIC then
                                        ret&=sprint(tokens[j][2])
                                elsif tokens[j][1]=KEYWORD and find(tokens[j][2],constants) then
                                        ret&=tokens[j][2]
                                else ret&="0"
                                end if
                                ret&="\n"
                                j+=1
                        elsif length(tokens)>(j+3) and (equal(tokens[j][2],sub_pre) or (length(sub_pre)=0 and atom(tokens[j+3][2]))) then
                                if length(sub_pre)=0 then j-=1 end if
                                if equal(tokens[j+2][2],sub_post) and
                                tokens[j+4][1]=PAR and (not find(tokens[j+3],subs)) and (not find(tokens[j+3],constants)) then
                                subs&={tokens[j+3][2]}
                                if not find_type(tokens[j+1][2]) then type_num=1 end if
                                func=type_num
                                if not types[func][4] then func=0 end if
                                params={}
                                sub_params={}
                                c_params={}
                                sub_end=length(tokens)
                                for i = j+5 to length(tokens) do
                                        if tokens[i][1]=PAR then sub_end=i exit
                                        elsif find_type(tokens[i][2]) and type_num-1 then
                                                if not sequence(tokens[i+1][2]) or length(tokens[i+1][2])=0 then tokens[i+1][2]=rand("zzzzz"-'a')+'a' end if
                                                if tokens[i+1][2][1]='*' then tokens[i+1][2]=tokens[i+1][2][2..length(tokens[i+1][2])] end if
                                                if find(tokens[i+1][2],reserved_words) then tokens[i+1][2]&='s' end if
                                                if find(')',tokens[i+1][2]) or find('(',tokens[i+1][2]) then tokens[i+1][2]=rand("zzzzz"-'a')+'a' end if
                                                if not sequence(tokens[i+1][2]) or length(tokens[i+1][2])=0 then tokens[i+1][2]=rand("zzzzz"-'a')+'a' end if
                                                if find(tokens[i+1][2],sub_params) then tokens[i+1][2]=rand("zzzzz"-'a')+'a' end if
                                                params&={types[type_num][3],tokens[i+1][2]}
                                                sub_params&={tokens[i+1][2]}
                                                c_params&={types[type_num][2]}
                                                if equal(tokens[i-1][2],"unsigned") then c_params[length(c_params)]="U"&c_params[length(c_params)]
                                                elsif equal(tokens[i-1][2],"const") then c_params[length(c_params)]="POINTER" --params[length(params)]="object"
                                                end if
                                        end if
                                end for
                                junk={{},{},{}}
                                for i = 1 to length(c_params) do
                                        junk[1]&="C_%s,"
                                        junk[2]&="%s %s,"
                                        junk[3]&="%s,"
                                end for
                                if length(c_params)>0 then
                                junk={junk[1][1..length(junk[1])-1],junk[2][1..length(junk[2])-1],junk[3][1..length(junk[3])-1]}
                                end if
                                if func then
                                glprocs&=sprintf(
"C%s=define_gl_func(\"%s\",{"&junk[1]&"},C_%s)\n",{tokens[j+3][2],tokens[j+3][2]}&c_params&{types[func][2]})
                                ret&=sprintf(
"global atom C%s\n"&
"global function %s("&junk[2]&")\n\treturn c_func(C%s,{"&junk[3]&"})\nend function\n",
{tokens[j+3][2],tokens[j+3][2]}&params&{tokens[j+3][2]}&sub_params)
                                else
                                glprocs&=sprintf(
"C%s=define_gl_proc(\"%s\",{"&junk[1]&"})\n",{tokens[j+3][2],tokens[j+3][2]}&c_params)
                                ret&=sprintf(
"global atom C%s\n"&
"global procedure %s("&junk[2]&")\n\tc_proc(C%s,{"&junk[3]&"})\nend procedure\n",
{tokens[j+3][2],tokens[j+3][2]}&params&{tokens[j+3][2]}&sub_params)
                                end if
                                j=sub_end+1
                                else
                                if length(sub_pre)=0 then j+=1 end if
                                j+=1
                                end if
                        else
                                j+=1
                        end if
                        
                else j+=1
                end if
        end while
return ret&glprocs
end function
global procedure make_c_include(sequence file_name,sequence out_name,sequence pre,sequence post,sequence l)
        atom file_handle
        object file
        sub_pre=pre
        sub_post=post
        lib=l
        file=get_tokens(sprintf("include %s\n",{file_name}))
        file_handle=open(out_name,"w")
        file=process_tokens(file)
        puts(file_handle,sprintf("include dll.e\nconstant %s=open_dll(\"%s.dll\")\n",{l,l})&file)
        close(file_handle)
end procedure
